\section{Introduction}

Debtags is the replacement for the Debian package sections that scales well
with the size of the archive.

It uses multiple categories per package (\emph{tags} in short), chosen from a
controlled vocabulary \footnote{\url{http://en.wikipedia.org/wiki/Controlled_vocabulary}},
organised borrowing principles of
faceted classification \footnote{\url{http://en.wikipedia.org/wiki/Faceted_classification}}.

Every tag belongs to a facet, which clearly defines its meaning and context.  A
facet is \emph{a point of view from which we look at the package archive}.

Some facets are quite generic:

\newcommand{\debtag}[1]{{\tt #1}}
\newcommand{\filecmd}[1]{{\tt #1}}
\newcommand{\debpackage}[1]{{\tt #1}}
\newcommand{\progvs}[1]{{\tt #1}}

\begin{itemize}
 \item \debtag{role}: role of the package in the system (program, plugin, documentation,
   development library...)
 \item \debtag{use}: main purpose of the program (browsing, chatting, searching...)
 \item \debtag{implemented-in}: language the software is implemented in (C, C++, ...)
 \item \debtag{interface}: user interface of the package (x11, commandline, text mode,
   web...)
 \item \debtag{works-with}: what kind of data can be processed with this package (audio,
   plain text, images...)
\end{itemize}

Since it is not compulsory for a package to have a tag from every facet defined
by Debtags, there are facets that are specific to some particular domain or
group of users:

\begin{itemize}
 \item \debtag{admin}: purpose of the package when doing system administration (backup,
   boot, logging...)
 \item \debtag{devel}: purpose of the package when doing software development (bugtracker,
   compiler, debugger, library...)
 \item \debtag{game}: what kind of game is provided by the package (adventure, arcade,
   sport...)
 \item \debtag{sound}: purpose of the package when working with sound and music (mixer,
   player, recorder, sequencer...)
\end{itemize}

These are some examples; there are of course many more.

These are some advantages of this system:

\begin{itemize}
 \item A package is not classified using a single concept, but using a
   superimposition of various different concepts, along different points of
   view.  This means that it is possible to create rather precise
   classifications, such as \debtag{role::program}, \debtag{interface::x11},
   \debtag{works-with::mail}, \debtag{use::viewing}, \debtag{uitoolkit::gtk},
   \debtag{implemented-in::c}.

 \item One does not need to have a category for everything, since concepts can be
   easily approximated.  For example, it does not make sense to introduce a
   \debtag{devel::lang:brainfuck} tag for just a couple of packages, but that can
   easily be approximated using  \debtag{devel::interpreter}, \debtag{devel::compiler} and
   \debtag{use::entertaining}.

 \item One can start a search from the most intuitive point of view.  Some people
   may approach an image editor starting from \debtag{use::viewing}, while some may
   approach it starting from \debtag{works-with::image}: for Debtags, it does not
   matter.

 \item Every tag is well defined.  Belonging to a facet gives tags a very precise
   meaning: compare a hypothetical tag \debtag{c++} with the tags
   \debtag{implemented-in::c++} and \debtag{devel::lang:c++} used by Debtags.
\end{itemize}

\section{Data sources}

This section lists all the sources of data provided by Debtags.  The formats of
all these data sources are documented in the Data formats section.

\subsection{Tag sources}

This section contains a list of ways to get tag information for packages.

\subsubsection{Packages file}

The Packages file contains \filecmd{Tag:} fields with tag information for every
package.

\subsubsection{Alioth database, revised}

The data that end up in the Packages file can also be found at
\url{svn://svn.debian.org/debtags/tagdb/tags}; these are the data coming from the
Alioth database, after manual review.

\subsubsection{Alioth unrevised}

The data contributed, either via the web
interface \footnote{\url{http://debtags.alioth.debian.org/todo.html}} or e-mail submissions,
is collected in a database on Alioth.

These data, which have not yet undergone manual reviewing, can be accessed at
\url{http://debtags.alioth.debian.org/tags/tags-current.gz}.

\subsubsection{Iterating.org}

Iterating \footnote{\url{http://www.iterating.com}}, a wiki-based software guide, are
providing a tag database with their ranking information at
\url{http://www.iterating.com/tags/tags-current.gz}.

This can be merged with the other tag data by adding
\begin{verbatim}
tags http://www.iterating.com/tags
\end{verbatim}
as a tag source in \filecmd{/etc/debtags/sources.list} and running \filecmd{debtags update}.

\subsubsection{Local merged tag information}

\filecmd{debtags update} generates a merged tag database that includes all the tag data
from all the tag sources configured in \filecmd{/etc/debtags/sources.list}.

It can be found in \filecmd{/var/lib/debtags/package-tags}, and it has an accompanying
index for fast access in \filecmd{/var/lib/debtags/package-tags.idx} and
\filecmd{/var/lib/debtags/pkgidx.idx}.

\subsection{Vocabulary sources}

The Debtags vocabulary, which describes the facets and tags available for use in
Debtags, can be obtained from subversion at
\url{svn://svn.debian.org/debtags/vocabulary/trunk/debian-packages} or via web at
\url{http://debtags.alioth.debian.org/tags/vocabulary.gz}.

A copy of the vocabulary is also included in the Debtags package to support
the tags provided with the Packages file.  It can be found in \filecmd{/usr/share/debtags/vocabulary}.

Finally, \filecmd{debtags update} generates a merged vocabulary that includes all the
vocabulary data from all the tag sources configured in
\filecmd{/etc/debtags/sources.list}.  It can be found in \filecmd{/var/lib/debtags/vocabulary},
and has an accompanying index for fast access in
\filecmd{/var/lib/debtags/vocabulary.idx}.

\section{Debtags procedures}

\subsection{Tagging packages}

\subsubsection{Tools}

Everyone can tag new packages using the web interface, \filecmd{debtags} or
\filecmd{debtags-edit}.

The main point of access for the web interface is the {\emph "Go tagging!"
page} \footnote{\url{http://debtags.alioth.debian.org/todo.html}}, but it is possible to access
the tag editor (\url{http://debtags.alioth.debian.org/edit.html}) for one package
directly using an URL like
\url{http://debtags.alioth.debian.org/edit.html?pkg=*pkgname*}

Tagging can also be done using \filecmd{debtags-edit}, a GUI application which is not as
good as the web interface, but allows offline working.  \filecmd{debtags-edit} has a
``File/Mail changes to central database'' option to send your changes to the
database on Alioth.

Tagging can also be scripted using \filecmd{debtags}: run \filecmd{debtags help tag} for quick
help on adding, removing and listing tags.  You can submit your local tag
changes using \filecmd{debtags submit}.

\subsubsection{Tips}

There are various tips for what tags to use for your packages:

\begin{itemize}
 \item Every package should have one or more tags from \debtag{role::}.
 \item Every package containing software should have one or more tags from
   \debtag{interface::}.
 \item Each package containing software or libraries should have one or more tags
   from \debtag{implemented-in::}.
\end{itemize}

The web interface will give you more.  In fact, there is a fascinating program
that scans the tag data for tag relationships and automatically generates more
tips.

If you want to do some more general QA work on tags, you can start from the
suggestions posted by Justin B. Rye at \url{http://lists.alioth.debian.org/pipermail/debtags-devel/2005-September/000845.html}:

\begin{verbatim}
> The following tools have been particularly useful for working out what
> unfamiliar packages are all about.
>
>  * apt-cache (obviously; but nb "apt-cache rdepends")
>  * apt-file ("does it put anything in /usr/bin?  In init.d/?")
>  * debman, in debian-goodies ("what does its man page say?")
>  * surfraw (instant lookups of packages.debian.org/foo)
\end{verbatim}

\subsection{Tag workflow}

This is the path of a tag contribution on its way to becoming a full part of
Debtags:

\begin{enumerate}
 \item The contribution arrives in the Alioth database, either using the web
    interface at \url{http://debtags.alioth.debian.org/todo.html} or via a mail
    submission.  It becomes visible right away on the Debtags pages on Alioth.
 \item I do a periodical manual review of the changes, approving the good ones and
    discarding what is obviously wrong.  This results in a tag database
    maintained on svn at \url{svn://svn.debian.org/debtags/tagdb/tags}
 \item From time to time I use the tags in svn to generate a "tag override" file
    and I upload it to the attention of the ftp-masters \footnote{\url{http://ftp-master.debian.org/}}
 \item The ftp-masters eventually install the override file in the archive and the
    changes become available to \filecmd{apt-get update}.
\end{enumerate}

The "override" file is a file that is used to amend (add or change fields in) the
control files written by the package maintainers.

I have run an experiment
(\url{http://lists.alioth.debian.org/pipermail/debtags-devel/2006-September/001334.html})
of allowing the maintainers to specify tags in the control file, but it has not
proven satisfactory:

\begin{itemize}
 \item some tags are more easily added by people who are not DDs: the maintainer
   can add \debtag{made-of::*} and \debtag{interface::*}, but may not be the best person to add
   tags such as \debtag{works-with::*} or \debtag{accessibility::*}.
 \item occasionally we do a reorganisation of the tag database (for example, we
   could rename \debtag{protocol::jabber} to \debtag{protocol::im:jabber} and it is not
   practical to ask all maintainers involved to reflect those changes in their
   control files.
 \item the web interface (\url{http://debtags.alioth.debian.org/edit.html}) is by far
   the best way to enter tags anyway.
\end{itemize}

\subsection{Creating new tags}

If you see the need for a new tag, post a message to the mailing
list (\url{http://lists.alioth.debian.org/mailman/listinfo/debtags-devel}).
An example can be found at
\url{http://lists.alioth.debian.org/pipermail/debtags-devel/2006-December/001500.html}.

This is a short checklist you can use before submitting a new tag:

\begin{itemize}
 \item It should represent a clear, atomic concept
 \item It should have a facet to fit in
 \item Find 6 or 7 packages in Debian that can make use of it
\end{itemize}

Don't forget to post the list of 6 or 7 packages together with the tag request,
so that after the tag is added it will also be associated to some packages.

Remember that categorisation in Debtags happens with a combination of tags;
this means that instead of having a \debtag{dvdplayer} tag, we have the combination
\debtag{use::playing}, \debtag{works-with::video}, \debtag{hardware::storage:dvd}.

These combinations also allow to create reasonable approximations of tags that
should not be added because they are not yet used by many packages. For
example, the tag \debtag{devel::lang:brainfuck} should not yet be added because the
corresponding packages in Debian are too few, but it can be reasonably
approximated using combinations of \debtag{devel::interpreter}, \debtag{devel::compiler}
and \debtag{use::entertaining}.


\subsection{Reorganising tags}
Sometimes it is necessary to reorganise the tag vocabulary.  This could entail
renaming a tag, splitting a tag into two or more different tags, or merging two
tags into one.

In such cases, the changes are announced and discussed on the mailing
list (\url{http://lists.alioth.debian.org/mailman/listinfo/debtags-devel})
before proceeding, and when the discussion reaches a conclusion I do my best
to implement the reorganisation without things breaking.

Implementing a reorganisation usually follows a procedure like this:

\begin{enumerate}
 \item Add the new tags to the vocabulary.
 \item Add a note to the short description of the tags that will be deleted
    marking them obsolete.
 \item Install the vocabulary in the Alioth database.
 \item Submit the new tags.
 \item Remove the obsolete tags.
 \item Remove the obsolete tags from the vocabulary.
\end{enumerate}

This procedure makes it so that it can be interrupted at any time without loss
of data, and people unaware of it can contribute tags without their
contributions being lost.


\subsection{Automated mass tagging}
Periodically, mass tagging of packages can be practical. For example, one
can easily infer library packages from the package names, and add the
library-related tags as appropriate.

For this task there is a script called \filecmd{autodebtag} in the subversion
repository at \url{svn://svn.debian.org/debtags/autodebtag/trunk}, which allows to
easily plug in new snippets of code.

autodebtag produces a tag patch that can be submitted to the alioth database
using \filecmd{debtags submit} after inspection.

autodebtag is however not scheduled to run automatically because I lack the
time for reviewing the big patches to make sure there are no flaws in the
scripts.

\section{Data formats}

This is a reference for the various file and data formats one may encounter
when working with debtags.  A list of data sources is found in the section
\emph{Available data sources}.


\subsection{Tag name}
The full tag name is composed of a \emph{facet name} followed by double colon,
followed by the tag name.

The facet name can technically contain anything except for a double colon or a
comma followed by a space; in practice however, only alphanumeric characters
and dashes are currently used.

The tag name can technically contain anything except for a comma followed by a
space; in practice, however, only alphanumeric characters, pluses, dashes and
colons are used.

Colons in the tag name are sometimes used to organise the tags of the same
facet in a hierarchical way.

Facet and tag names are case sensitive.

\subsubsection{Examples of tag names}

\begin{itemize}
    \item \debtag{devel::bugtracker}
    \item \debtag{devel::code-generator}
    \item \debtag{devel::i18n}
    \item \debtag{devel::lang:c}
    \item \debtag{devel::lang:c++}
    \item \debtag{implemented-in::c}
    \item \debtag{implemented-in::c++}
    \item \debtag{interface::3d}
    \item \debtag{interface::commandline}
    \item \debtag{interface::text-mode}
    \item \debtag{works-with-format::xml}
    \item \debtag{works-with-format::xml:rss}
    \item \debtag{works-with-format::xml:xslt}
\end{itemize}

\subsection{Tags in the Packages files}
The tags of a package in the Debian Packages file are stored in the \filecmd{Tag:}
header.

The format is a simple list of tags, sorted in alphabetical order, and
separated by comma and one or more spaces.  The separator is matched by the
regular expression: \begin{verbatim}/,\s+/\end{verbatim}

In order to cope with maximum line length limitations in the Packages file
format, multiple tags belonging to the same facet are grouped using curly
braces.

\subsubsection{Examples of tag fields in the Packages file}

\begin{verbatim}
# Empty field
Tag:
# Field with only one tag
Tag: web::server
# Field with many tags
Tag: made-of::data:font, role::app-data, use::printing, works-with::text,
     works-with-format::postscript
# Field with grouped tags
Tag: made-of::{data:font,data:html,data:pdf,data:tex}, role::app-data,
     role::documentation, suite::TODO, use::typesetting,
     works-with::{font,image,image:vector,text},
     works-with-format::{pdf,postscript,tex}, x11::font
\end{verbatim}


\subsection{Tag database}
Many debtags and debtags-related tools can store an entire tag database in a
single file.

Example uses are:

\begin{itemize}
 \item The available tag information stored by \filecmd{debtags} in \filecmd{/var/lib/debtags/package-tags}
 \item The tag database downloadable from \url{http://debtags.alioth.debian.org/tags/tags-current.gz}
 \item The reviewed tag database in \url{svn://svn.debian.org/debtags/tagdb/tags}
 \item The input and output of the \filecmd{tagcoll} utility
\end{itemize}

Every line in the file is able to associate one or more packages to zero or
more tags.

A line is composed of a list of package names and a list of tag names,
separated by a colon and one or more spaces.  This separator can be matched by
the regular expression: \begin{verbatim}/:\s+/\end{verbatim}

In contrast, the package names and tag names are separated by a comma and one or
more spaces, as represented by the regular expression: \begin{verbatim}/,\s+/`\end{verbatim}

A line of the tag database can therefore be parsed using the following perl
code:

\begin{verbatim}
my ($packages, $tags) = split(/:\s+/, $line);
my @packages = split(/,\s+/, $packages);
my @tags = split(/,\s+/, $tags);
\end{verbatim}

A package name can appear in multiple lines of the tag database, but not on the
same line: this makes it possible to easily merge multiple tag database by just
concatenating the files.  For convenience, however, most debtags tools create
databases in which package names appear only once.

No curly-brace grouping is allowed in a tag database.

The \filecmd{tagcoll} tool can be used to work with information in this format.  These
are some example operations:

\begin{verbatim}
# Merge tag informations so that package names only appear once in the
# file
tagcoll -g copy my-tagdb

# Convert a packages -> tags mapping to a tags -> packages mapping
tagcoll reverse my-tagdb

# Compute the differences between two tag databases
tagcoll diff my-tagdb1 my-tagdb2 > tag-patch

# Apply a tag patch
tagcoll -p tag-patch copy my-tagdb1 > same-as-my-tagdb2

# Filter a tag database, keeping only the lines matching a given tag
# expression
tagcoll grep 'role::program && interface::x11' my-tagdb
\end{verbatim}

Empty lists of tags can be used to record that a package is known to have no
tags, but they are usually discarded.

\subsubsection{Example lines of a tag database}

\begin{verbatim}
xmame-x: hardware::emulation
abakus: field::mathematics, interface::x11, role::program, scope::utility,
        suite::kde, uitoolkit::qt, x11::application
gnomermind, gnotepad+, gnotime: interface::x11, role::program, scope::application,
                                suite::gnome, uitoolkit::gtk, x11::application
\end{verbatim}


\subsection{Vocabulary}

The tag vocabulary, which can be found in \filecmd{/var/lib/debtags/vocabulary}, in
\url{http://debtags.alioth.debian.org/tags/vocabulary.gz} and in
\url{svn://svn.debian.org/debtags/vocabulary/trunk/debian-packages}, has the same
RFC822-style format as the Debian Packages file.

The debtags vocabulary contains two kinds of records: a facet description and a
tag description.  A facet description starts with the "Facet:" header, while
the tag description starts with the "Tag:" header.

Facet and tag records usually contain the "Description:" field that has the
exact same behaviour as the "Description:" field in the \filecmd{debian/control} file,
including the distinction between short and long description, the dot to
represent empty lines and the other formatting rules.

There can be other fields besides "Tag:", "Facet:" and "Description:", but they
are currently ignored.

\subsubsection{Example record of a tag vocabulary}

\begin{verbatim}
Facet: protocol
Description: Network Protocol
Status: draft

Tag: protocol::TODO
Description: Need an extra tag
 The package can be categorised along this facet, but the right tag for it is
 missing.
 .
 Mark a package with this tag to signal the vocabulary maintainers of cases
 where the current tag set is lacking.

Tag: protocol::atm
Description: ATM
 Asynchronous Transfer Mode, a high speed protocol for communication between
 computers in a network.
 .
 While ATM is used to implement *DSL networks, it has never gained widespread
 use as a technology for building local area networks (LANs), for which it was
 originally intended.
 .
 Link: http://en.wikipedia.org/wiki/Asynchronous_Transfer_Mode

Tag: protocol::bittorrent
Description: BitTorrent
 BitTorrent is a protocol for peer-to-peer based file distribution over
 network.
 .
 Although the actual data transport happens between BitTorrent clients, one
 central node, the so-called trackers, is needed to keep a list of all clients
 that download or provide the same file.
 .
 Link: http://www.bittorrent.com/
 Link: http://en.wikipedia.org/wiki/BitTorrent
\end{verbatim}

\subsection{Tag sources.list}

The \filecmd{debtags} tool uses a \filecmd{sources.list} file similar to the one used by APT,
to configure a number of tag data sources.  The format is the same as APT,
except that only the sources starting with \filecmd{tags} are considered by \filecmd{debtags}.

All sources not starting with \filecmd{tags} are ignored, and this could allow sharing
a sources.list between APT and debtags.  Unfortunately however, APT however
does not currently ignore the \filecmd{tags} sources, and refuses to work if it finds
one.

\subsubsection{Example sources.list file}

\begin{verbatim}
# Source locations to get tag database info
#
# You can specify more than one; during update, debtags will merge the contents
# of all the sources.  The merged data can be found in
# /var/lib/debtags/package-tags and /var/lib/debtags/vocabulary.

# Reviewed tag data from the APT Packages file
tags apt://

# Regularly updated, but unchecked, database on the web
# This tries to access the files:
#   http://debtags.alioth.debian.org/tags/tags-current.gz
#   http://debtags.alioth.debian.org/tags/vocabulary.gz
#
# The vocabulary, if existing, is used to filter the tag database: all
# tags in tags-current.gz are discarded if they are not found in
# the vocabulary.  After filtering, the vocabulary is merged with the
# other available vocabulary information.
#
# If the vocabulary is not found in the tag source, the tag data is
# filtered using the system vocabulary.
#
#tags http://debtags.alioth.debian.org/tags/

# Package rating from http://www.iterating.com
#tags http://www.iterating.com/tags

# Example of locally maintained custom tag data
#
# You can provide your own tag data.  To do so, place a file called
# vocabulary.gz and a file called tags-current.gz in a directory, and use the
# directory as a tag source.
#
# In the example given below, you would place the tag data in
# /etc/debtags/mytags/tags-current.gz, and the vocabulary data in
# /etc/debtags/mytags/vocabulary.gz
#
# The format of tags-current.gz is described in the tagcoll(1) manpage and the
# file is similar to /var/lib/debtags/package-tags.
#
# The format of vocabulary.gz is like the Debian Packages file, and the file is
# similar to /var/lib/debtags/vocabulary.
#
#tags file:/etc/debtags/mytags
\end{verbatim}

\subsection{Binary index}

\filecmd{debtags update} creates an indexed version of the tag database in
\filecmd{/var/lib/debtags/package-tags.idx}, an index for the tag vocabulary in
\filecmd{/var/lib/debtags/vocabulary.idx} and an index for package names in
\filecmd{/var/lib/debtags/pkgidx.idx}.

All these indices are built to be quickly accessed using \filecmd{mmap}.

All these \filecmd{.idx} files contain a chain of indexes, each prefixed by an \filecmd{int}
value stating its length.  The structure of an \filecmd{idx} file is therefore:

\begin{verbatim}
[size of index 1][index1][size of index 2][index2]...
\end{verbatim}

Code for accessing the indexes is found in the package \debpackage{libtagcoll-dev}, in
\filecmd{diskindex/mmap.h}.

\subsubsection{The vocabulary index}

The vocabulary index contains a facet index and a tag index.

To build the \emph{facet index}, facet names are sorted alphabetically and then
assigned a number starting from 0.

The facet index begins with one table with one \filecmd{int} value per facet,
containing the offset of the facet data that follows the table.  Just after the
table begins the facet data, as a sequence of structures:

\begin{verbatim}
struct Item {
    // Offset of the facet record in the text vocabulary file
    int offset;
    // Size of the facet record in the text vocabulary file
    int size;
    // Tag index ID of the first tag in this facet
    int firsttag;
    // Tag index ID of the last tag in this facet
    int lasttag;
    // Facet name (0-terminated)
    const char name[];
};
\end{verbatim}

The facet index allows $O(1)$ retrieval of a facet record by facet ID and
$O(\log{number of facets})$ retrieval of a facet ID from a facet name, as the
facets are sorted alphabetically and this allows to use binary search on the
facet offset table.

The facet index also allows direct access to the list of tags for a facet,
providing a range of tag index IDs.


The \emph{tag index} is built similarly to the facet index: the tags are sorted
alphabetically and then assigned a number starting from 0.

The tag index begins with one table with one \filecmd{int} value per tag, containing
the offset of the tag data that follows the table.  Just after the table begins
the tag data, as a sequence of structures:

\begin{verbatim}
struct Item {
	// Offset of the tag record in the text vocabulary file
	int offset;
	// Size of the tag record in the text vocabulary file
	int size;
	// Facet index ID of the facet that contains this tag
	int facet;
	// Tag name (0-terminated, includes the facet name)
	const char name[];
};
\end{verbatim}

The tag index allows $O(1)$ retrieval of a tag record by tag ID and
$O(\log{number of tags})$ retrieval of a tag ID from a tag name, as the tags are
sorted alphabetically and this allows to use binary search on the tag offset
table.

The tag index also allows $O(1)$ access to the facet information for a tag,
using the facet index ID provided.

Tag index entries and facet index entries can be padded after the tag or facet
name to guarantee alignment of structures to machine word boundaries.

The code to access the vocabulary index can be found in \debpackage{libept-dev} in
\filecmd{ept/cache/debtags/vocabulary.h} and
\filecmd{ept/cache/debtags/vocabularymerger.h}:

\begin{verbatim}
// Build the facet index
void VocabularyMerger::FacetIndexer::encode(char* buf) const 
{
	int pos = vm.facets.size() * sizeof(int);

	for (std::map<std::string,
         FacetData>::const_iterator f = vm.facets.begin();
         f != vm.facets.end(); f++)
	{
		((int*)buf)[f->second.id] = pos;

		// offset of record in vocabulary
		*(int*)(buf+pos) = f->second.ofs;
		pos += sizeof(int);

		// size of record in vocabulary
		*(int*)(buf+pos) = f->second.len;
		pos += sizeof(int);

		// id of first tag
		*(int*)(buf+pos) = f->second.tags.begin()->second.id;
		pos += sizeof(int);

		// id of last tag
		*(int*)(buf+pos) = f->second.tags.rbegin()->second.id;
		pos += sizeof(int);

		// name (0-terminated)
		memcpy(buf + pos, f->first.c_str(), f->first.size() + 1);
		pos += f->first.size() + 1;
		
		// Align to int boundaries
		if ((pos % sizeof(int)) != 0)
			pos = (pos + sizeof(int)) / sizeof(int) * sizeof(int);
	}
}

// Build the tag index
void VocabularyMerger::TagIndexer::encode(char* buf) const 
{
	int pos = vm.tagCount * sizeof(int);

	for (std::map<std::string,
         FacetData>::const_iterator f = vm.facets.begin();
         f != vm.facets.end(); f++)
	{
		for (std::map<std::string, TagData>::const_iterator t = f->second.tags.begin();
				t != f->second.tags.end(); t++)
		{
			((int*)buf)[t->second.id] = pos;

			// offset of record in vocabulary
			*(int*)(buf+pos) = t->second.ofs;
			pos += sizeof(int);

			// size of record in vocabulary
			*(int*)(buf+pos) = t->second.len;
			pos += sizeof(int);

			// id of facet
			*(int*)(buf+pos) = f->second.id;
			pos += sizeof(int);

			// name (0-terminated)
			string name = f->first + "::" + t->first;
			memcpy(buf + pos, name.c_str(), name.size() + 1);
			pos += name.size() + 1;
			
			// Align to int boundaries
			if ((pos % sizeof(int)) != 0)
				pos = (pos + sizeof(int)) / sizeof(int) * sizeof(int);
		}
	}
}
\end{verbatim}

\subsubsection{The package name index}

The package name index makes it possible to quickly retrieve a package name using
the package ID that the APT index assigns to it.

This is needed to support creating a tag index that uses only integer values,
as the APT library does not seem to provide a quick way to go from package ID
to package name.

The index contains an int table and a string table.  The int table contains an
int per package ID and points to the package name in the string table.

Since the APT IDs are contiguous, the int table can be indexed directly using
the package ID, and this allows very fast and $O(1)$ retrieval of the package
name.

The code to access the package name index can be found in \debpackage{libept-dev} in
\filecmd{ept/cache/debtags/pkgidx.h}, and the code to generate the index is found in
the ``Generator'' class in \filecmd{ept/cache/debtags/update.tcc}:

\begin{verbatim}
// Get the package name from the package ID
const char* name(int id) const
{
	if (id >= 0 || static_cast<unsigned>(id) < size())
		return m_buf + ((int*)m_buf)[id];
	return NULL;
}

// Build the package name index
void encode(char* buf) const
{
	typedef typename ept::t::cache::Package<C> Package;

	// First sort the packages by ID
	std::vector<Package> pkgs;
	pkgs.resize(m_pkgs.index().packageCount() + 1);
	for (typename Index::iterator i = m_pkgs.index().begin(); i != m_pkgs.index().end(); ++i)
		pkgs[i->ondiskId()] = *i;

	// Then write them out
	int pos = pkgs.size() * sizeof(int);
	int idx = 0;
	for (typename std::vector<Package>::const_iterator i = pkgs.begin(); i != pkgs.end(); ++i)
	{
		((int*)buf)[idx++] = pos;
		memcpy(buf + pos, i->name( std::string( "invalid" ) ).c_str(),
		   i->name( std::string( "invalid" ) ).size() + 1);
		pos += i->name( std::string( "invalid" ) ).size() + 1;
	}
}
\end{verbatim}


\subsubsection{The tag index}

Using the vocabulary tag index we can have fast bidirectional mapping of tag
names to integers; using the APT library and the package name index we can have
fast bidirectional mapping of package names to integers.  This means that we
can encode the association of packages and tags using only fixed-length integer
values.

The tag index contains two symmetrical indexes with the same format: the first
one allows retrieval of an array of tag IDs from a package ID, and the second
one allows retrieval of an array of package IDs given a tag ID.

The format of one int mapping is as follows:

\begin{verbatim}
[offset of mapping for item 0, offset of mapping for item 1...]
[size of array][sorted array of ints pointed by index 0]
[size of array][sorted array of ints pointed by index 1]
[size of array][sorted array of ints pointed by index 2]
[...]
[number of items in the mapping]
\end{verbatim}

To get the list of tag IDs associated to a package ID, we use the package ID as
the index of the offset table, and we obtain the offset of the tag IDs.

Using the tag IDs offset, we can read the size of the tag ID array and the
array just afterwards.

This allows to perform various fast operations:

\begin{enumerate}
 \item Lookup of a tag list from a package ID in $O(1)$
 \item Fast computation of merged or intersected tag lists, by exploiting the fact
    that the arrays of tag IDs are sorted.
\end{enumerate}

Since two symmetrical mappings are stored, this is all valid also from all
operations that require getting the list of packages associated to a tag, or
the merged or intersected lists of packages associated to a number of tags.

The code to access an int mapping is found in \debpackage{libtagcoll-dev} in
\filecmd{tagcoll/diskindex/int.h}:

\begin{verbatim}
// Get the array of tag IDs associated to a package ID
// (or the array of package IDs associated to a tag ID, depending on
//  what index we are accessing)
const int* data(int val) const
{
	return (val >= 0 && (unsigned)val < size()) ? buf() + ofs(val) + 1 : 0;
}
// Get the size of an ID array
size_t size(int val) const
{
	return (val >= 0 && (unsigned)val < size()) ? buf()[ofs(val)] : 0;
}
// Get the number of mappings in the index
size_t size() const { return ofs(0); }

/**
 * Creates an on-disk index to use for IntIndex
 */
class IntIndexer : public MMapIndexer, public std::vector<std::set<int> >
{
public:
	/// Store the key->val mapping into the indexer
	void map(unsigned int key, int val)
	{
		if (size() <= key)
			resize(key + 1);
		(*this)[key].insert(val);
	}
	
	/// Return the size of the encoded index data
	virtual int encodedSize() const;

	/// Write the index data in the given buffer, which should be at least
	/// encodedSize bytes
	virtual void encode(char* buf) const
	{
		int* buf = (int*)cbuf;
		int pos = size();
		for (size_t i = 0; i < size(); i++)
		{
			buf[i] = pos;
			buf[pos++] = (*this)[i].size();
			for (set<int>::const_iterator j = (*this)[i].begin(); j != (*this)[i].end(); j++)
				buf[pos++] = *j;
		}
	}
};
\end{verbatim}

The code to implement fast tag operations using the two symmetrical indexes is
found in \debpackage{libtagcoll-dev} in \filecmd{tagcoll/coll/intdiskindex.h} and in
\debpackage{libept-dev} in \filecmd{ept/cache/debtags/tagmap.h}.

\section{Debtags algorithms}

\subsection{Relevance scoring}

Suppose you have a filtering operation $O$ (such as a full-text search) that
operates a selection on packages, and returns you a subset $P1$ of the total
set of packages $P$.

It is possible to compare $P$ and $P1$ and score each tag by how much it is
related to $O$.

Define the cardinality of a tag $T$ as the number of packages that have the
tag.

The relevance scoring function for a tag $T$ after a filtering operation is:

$$
\frac{ \mbox{cardinality of } T \mbox{ in } {P1}^2}{\mbox{cardinality of } T \mbox{ in } P}
$$

that is, the square of the cardinality of $T$ in $P1$ divided by the
cardinality of $T$ in $P$.

This simple scoring function allows to correlate tags to any other search
operation on packages, allowing to fit a context sensitive tag search in almost
any kind of package interface.

You can see this function in action at:

\begin{itemize}
 \item The Smart Package Search page \footnote{\url{http://debtags.alioth.debian.org/ssearch.html}}
 \item The \filecmd{smartsearch}, \filecmd{wxssearch} and \filecmd{tagsByRelevance} examples of the
   \debpackage{python-debian} package
 \item The ``Add rel'' button in \filecmd{debtags-edit}
 \item The \filecmd{pmnew} \footnote{\url{http://www.enricozini.org/2007/debtags/pmdraft-commandline.html}}
   and \filecmd{pmnew-gui} \footnote{\url{http://blogs.hurdfr.org/arnau/?title=pmnew\_gui\_announcement}}
   prototypes
 \item The \filecmd{debtags smartsearch} function.
\end{itemize}


\subsection{Tag search}
The relevance scoring can also be used to implement a smart tag search
function that gives far better results than a full text search on tag names and
descriptions:

\begin{enumerate}
 \item Use the keywords to perform a full text search on the package descriptions
 \item Use the results to score tags by relevance, and show the most relevant tags
\end{enumerate}

Besides using this technique to search tags, it can be used to turn a keyword
search (which is easy to input) into a tag search (which easy to navigate).


\subsection{Discriminance scoring}

Another useful scoring function is by "discriminance".

Suppose you have an interface that shows a list of tags and allows users to
perform the two actions:

\begin{itemize}
 \item "I want only packages that have this tag"
 \item "I want only packages that do not have this tag"
\end{itemize}

Then it becomes important to have a scoring function that tells you what are
those packages that, when chosen in either of these actions, would give the
shortest resulting package list.

The function is simple to compute:

\begin{itemize}
 \item let $P$ be the number of available packages
 \item let $T$ be the cardinality of a tag
 \item then the discriminance index is simply $\min{T, P-T}$
\end{itemize}

This scoring function can be recomputed after every selection operated by the
user.  The resulting interface allows a user to quickly get to the packages
they need without having a clear idea of what they actually need.

\section{Debtags development}

\subsection{Python libraries}

The Debtags python library is not as complete as the C++ library but it's the
best place to start playing with Debtags and prototyping code.

It can be found as part of the \debpackage{python-debian} package, which also comes with
many examples.  All methods are documented, and the package has a
\filecmd{README.Debtags} file with the aggregated documentation.

The core of the Python library is the ``DB'' object, which stores the mapping
from package names to tag names and vice versa.  Packages and tags are
represented as simple strings.


\subsection{C++ libraries}

There are two C++ libraries that can be used to manipulate tag data:
\debpackage{libtagcoll} and \debpackage{libept}.

\debpackage{libtagcoll} provides generic functions to handle ``items'' tagged with ``tags'',
without putting any limit on what an ``item'' and a ``tag'' are.

\debpackage{libept} is designed to be the engine of a full-featured package manager
application, and it implements a specialisation of \debpackage{libtagcoll} for the Debian
and Debtags case.  It is currently used as the engine for the \debpackage{adept} package
manager.


\subsubsection{libtagcoll}

The library can be used to work with Debian packages and Debtags tags, or with
books and categories, or even people and IRC channels.  The item and tag types
are template parameters, and the only requirement on the underlying type is
that it can be stored in a \progvs{std::set}.

The library itself is a collection of all sorts of useful code, divided in
various sections:

\begin{itemize}
 \item \progvs{input} is an input stream abstraction used to support deserialisation of
   tag data.
 \item \progvs{stream} is a collection of functions to handle item and tag information as
   a stream, and it's useful to perform analysis and changes on the fly while
   reading or writing tag information.
 \item \progvs{coll} contains various different implementations of collections of tagged
   items, that the library calls "\emph{tagged collections}".
 \item \progvs{diskindex} contains the code to implement a fast, read only index for tag
   information.
 \item \progvs{tagexpr} contains the code to build and evaluate binary tag expressions as
   can be seen in \filecmd{tagcoll grep} and \filecmd{debtags search}.
\end{itemize}


\subsubsection{libept}

\debpackage{libept} provides abstractions for all the elements that a package manager
application needs to handle: packages, versions, dependencies, caches, tags
and so on.

The main design feature of \debpackage{libept} is that the library can be reconfigured to
use different kinds of packages and caches, allowing a package manager to be
easily from Debian to another distribution based on different technology.

To achieve this, all classes are templatised on a \emph{configuration} class, that
defines what are the classes that implement all the various kinds of components
used by the library.

In \debpackage{libept}, the code that concerns Debtags is found in \filecmd{ept/cache}, and its
main parts are:

\begin{itemize}
 \item \filecmd{tag.h} implements the \progvs{Facet} and \progvs{Tag} objects.
 \item \filecmd{debtags/vocabulary.h} implements access to the Debtags vocabulary, through
   the fast on-disk index.  It also allows to create \progvs{Facet} and \progvs{Tag} objects
   from facet and tag anmes.
 \item \filecmd{debtags/tagmap.h} implements the association between \progvs{Package} and \progvs{Tag}
   objects, using the fast on-disk index.  This is the part that implements the
   specialisation of \debpackage{libtagcoll} for Debtags.
 \item \filecmd{debtags/update.h} implements rebuilding all the data files and indexes in
   the \filecmd{/var/lib/debtags} directory
\end{itemize}


\subsection{Javascript libraries}

At \url{http://debtags.alioth.debian.org/js/debtags.js}
there is the Javascript library that is used to support the various Debtags web
applications.

If you are planning to handle Debtags information using Javascript, it probably
contains code worth recycling.

\section{Debtags resources}

This chapter is a collection of the software that has been written that makes
use of Debtags.

\subsection{Software packaged in Debian}

\subsubsection{\filecmd{apt-cache} and \filecmd{grep-dctrl}}
While these tools do not know Debtags directly, they can show and process tags
as part of their general handling of the Packages file.

In particular, \filecmd{apt-cache} can show tags, and this is helpful go get some extra
information like the user interface or the implementation language.

\filecmd{grep-dctrl} instead can perform matches on the \progvs{Tag:} field just like with any
other field.

\subsubsection{\filecmd{aptitude}}

Aptitude can show tag data and has a somehow limited "New Debtags Browser" that
allows to browse packages by tags.

\subsubsection{\filecmd{debtags}}

Debtags is what is needed to maintain a proper tag database in
\filecmd{/var/lib/debtags}.  It allows to perform various queries, and also to
contribute tags back to the Alioth database.

\subsubsection{\filecmd{adept}}

Adept is the graphical package manager for KDE, and it has good support for
searching using Debtags.

\subsubsection{\filecmd{packagesearch}}

Packagesearch is a graphical tool for finding packages that tries to allow
searching using all sorts of package information, including Debtags.

\subsubsection{\filecmd{debtags-edit}}

Debtags-edit is a graphical tool for tagging packages, but it also allows to
perform various package searches, also using debtags.

\subsubsection{\filecmd{tagcoll}}

Tagcoll is not a tool specific for Debtags, but it can handle general item/tag
mappings read from text files.

It can however be used in combination with Debtags to perform further
operations on its output.

\subsubsection{\debpackage{python-debian}}

Python-debian is not a tool but a collection of Debian-specific python
libraries that include Debtags support.

Among its examples, however, are various interesting prototypes that make use
of Debtags:

\begin{itemize}
 \item \filecmd{pkgwalk} (\url{http://www.enricozini.org/2007/debtags/pkgwalk.html})
   navigates between related Debian packages
 \item \filecmd{smartsearch} Python reimplementation of \filecmd{debtags smartsearch}
 \item \filecmd{tagminer} (\url{http://www.enricozini.org/2007/debtags/tagminer.html})
   given a file, it chooses some Debtags tags based on its type and shows a list of
   packages that could work with that file
 \item \filecmd{wxssearch} graphical smart search implementation
\end{itemize}


\subsection{Web applications}

\begin{itemize}
 \item Go tagging! (\url{http://debtags.alioth.debian.org/todo.html}) is the starting
   point for contributing to the categorisation.  It shows packages that need
   tagging sorted by popularity, so that the packages most used get tagged
   first.

   The Go tagging! page has a
   "Maintainer view" that can be used by Debian maintainers to check the
   tagging status of their packages.  The maintainer view is also linked from 
   the Debian Developer's Packages Overview (\url{http://qa.debian.org/developer.php}).
 \item The tag editor (\url{http://debtags.alioth.debian.org/edit.html}) can also be
   accessed directly and allows lookup of packages by name, or it is possible
   to link to the editor for one specific package with links in the form
   \url{http://debtags.alioth.debian.org/edit.html?pkg=*packagename*}
 \item The smart search page (\url{http://debtags.alioth.debian.org/ssearch.html})
   contains a smart search implementation for the web.
 \item The tag cloud (\url{http://debtags.alioth.debian.org/cloud/}) is a navigable tag
   cloud view of the Debian archive, written by Erich Schubert.
 \item \filecmd{popsuggest} (\url{http://people.debian.org/~enrico/popsuggest}) is an interface
   that tries to provide suggestions about packages to install after
   correlating your package list with the popularity contest (\url{http://popcon.debian.org/})
   database.  It uses Debtags to organise and filter the output.

 \item There is also a machine-friendly way to query the popsuggest data,
   documented in my Secret Debian Internals presentation (\url{http://people.debian.org/~enrico/talks/20070225-Fosdem/index.html})
\end{itemize}

\subsubsection{The package manager prototypes}

I've recently started experimenting with new ideas for package
managers (\url{http://www.enricozini.org/2007/debtags/pmdraft.html}), which so far
resulted in two more prototypes:

\begin{itemize}
 \item \filecmd{pmnew} (\url{http://www.enricozini.org/2007/debtags/pmdraft-commandline.html}), a
   prototype advanced commandline interface to find packages to install
 \item \filecmd{pmnew-gui} (\url{http://blogs.hurdfr.org/arnau/?title=pmnew\_gui\_announcement}), a
   prototype advanced GUI to find packages to install, written with Arnaud
   Fontaine.
\end{itemize}

\section{Links}

\begin{itemize}
 \item The Debtags website (\url{http://debtags.alioth.debian.org})
 \item The "Go tagging!" page, starting point for contributing to the tag
   database (\url{http://debtags.alioth.debian.org/todo.html})
 \item The Debtags mailing list (\url{http://lists.alioth.debian.org/mailman/listinfo/debtags-devel})
 \item The Debtags FAQ (\url{http://debtags.alioth.debian.org/faq.html})
 \item "A cute introduction to Debtags", paper for the Debconf5 conference (\url{http://debtags.alioth.debian.org/paper-debtags.html})
\end{itemize}
